umbrello: ClassifierListPage Class Reference

umbrello 2.38.2 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Slots | Protected Member Functions | Protected Attributes | Private Member Functions | Private Attributes | List of all members
ClassifierListPage Class Reference

A dialog page to display classifier properties. More...

`#include <classifierlistpage.h>`

Inheritance diagram for ClassifierListPage:

## Public Member Functions
| ClassifierListPage (QWidget *parent, UMLClassifier *classifier, UMLDoc *doc, UMLObject::ObjectType type)
virtual | ~ClassifierListPage ()
void | apply ()
Public Member Functions inherited from DialogPageBase
| DialogPageBase (QWidget *parent)
virtual | ~DialogPageBase ()
virtual bool | isModified ()

## Protected Slots
void | slotActivateItem (QListWidgetItem *item)
void | slotMenuSelection (QAction *action)
void | slotListItemCreated (UMLObject *object)
void | slotListItemModified ()
void | slotRightButtonPressed (const QPoint &p)
void | slotDoubleClick (QListWidgetItem *item)
void | slotTopClicked ()
void | slotUpClicked ()
void | slotDownClicked ()
void | slotBottomClicked ()
void | slotNewListItem ()
void | slotDelete ()
void | slotProperties ()

## Protected Member Functions
void | reloadItemListBox ()
void | hideArrowButtons (bool hide)
Protected Member Functions inherited from DialogPageBase
virtual void | keyPressEvent (QKeyEvent *event)

## Protected Attributes
UMLObject::ObjectType | m_itemType
UMLClassifier * | m_pClassifier
UMLClassifierListItem * | m_pLastObjectCreated
QPushButton * | m_pNewClassifierListItemButton
QPushButton * | m_pDeleteListItemButton
QPushButton * | m_pPropertiesButton
bool | m_bSigWaiting
Protected Attributes inherited from DialogPageBase
bool | m_isModified

## Private Member Functions
void | setupPage ()
void | setupListGroup (int margin)
void | setupDocumentationGroup (int margin)
void | setupMoveButtons (QHBoxLayout *parentLayout)
void | setupActionButtons (const QString &itemType, QVBoxLayout *parentLayout)
void | enableWidgets (bool state)
void | saveCurrentItemDocumentation ()
virtual UMLClassifierListItemList | getItemList ()
bool | addToClassifier (UMLClassifierListItem *classifier, int position=-1)
bool | takeItem (UMLClassifierListItem *listItem, bool seekPeerBefore, int &peerIndex)
void | deleteMenu ()
void | printItemList (const QString &prologue)

## Private Attributes
QGroupBox * | m_docGB
QGroupBox * | m_pItemListGB
KTextEdit * | m_docTE
CodeTextEdit * | m_pCodeTE
QListWidget * | m_pItemListLB
QToolButton * | m_pTopArrowB
QToolButton * | m_pUpArrowB
QToolButton * | m_pDownArrowB
QToolButton * | m_pBottomArrowB
UMLDoc * | m_doc
UMLClassifierListItem * | m_pOldListItem

## Detailed Description

A dialog page to display classifier properties.

A dialog page to display classifier list properties. This is not normally setup by you. It is used by the ClassPropertiesDialog and new class wizard.

Author
  Paul Hensgen, Jonathan Riddell Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ ClassifierListPage()

ClassifierListPage::ClassifierListPage | ( | QWidget * | parent,
|  | UMLClassifier * | classifier,
|  | UMLDoc * | doc,
|  | UMLObject::ObjectType | type
| ) |  |

Sets up the ClassifierListPage.

Parameters

  parent | The parent to the ClassAttPage.
  classifier | The Concept to display the properties of.
  doc | The UMLDoc document
  type | The type of listItem this handles

## ◆ ~ClassifierListPage()

ClassifierListPage::~ClassifierListPage | ( |  | ) |
| virtual

Standard destructor.

## Member Function Documentation

## ◆ addToClassifier()

bool ClassifierListPage::addToClassifier | ( | UMLClassifierListItem * | listitem,
|  | int | position = `-1`
| ) |  |
| private

Attempts to add a UMLClassifierListItem to m_pClassifier.

Parameters

  listitem | Pointer to the classifier list item to add.
  position | Index at which to insert into the list.

Returns
  true if the classifier could be added

## ◆ apply()

void ClassifierListPage::apply | ( |  | ) |

Will move information from the dialog into the object. Call when the ok or apply button is pressed.

## ◆ deleteMenu()

void ClassifierListPage::deleteMenu | ( |  | ) |
| private

## ◆ enableWidgets()

void ClassifierListPage::enableWidgets | ( | bool | state | ) |
| private

Set the state of the widgets on the page with the given value.

Parameters

  state | The state to set the widgets as.

## ◆ getItemList()

UMLClassifierListItemList ClassifierListPage::getItemList | ( |  | ) |
| privatevirtual

Get classifier list items.

## ◆ hideArrowButtons()

void ClassifierListPage::hideArrowButtons | ( | bool | hide | ) |
| protected

Sets the visibility of the arrow buttons.

Parameters

  hide | true hides the arrow buttons

## ◆ printItemList()

void ClassifierListPage::printItemList | ( | const QString & | prologue | ) |
| private

Utility for debugging, prints the current item list. Only effective if VERBOSE_DEBUGGING is defined.

## ◆ reloadItemListBox()

void ClassifierListPage::reloadItemListBox | ( |  | ) |
| protected

Loads the Item List Box.

## ◆ saveCurrentItemDocumentation()

void ClassifierListPage::saveCurrentItemDocumentation | ( |  | ) |
| private

Saves the documentation for the currently selected item.

## ◆ setupActionButtons()

void ClassifierListPage::setupActionButtons | ( | const QString & | itemType,
|  | QVBoxLayout * | parentLayout
| ) |  |
| private

Sets up the action buttons.

Parameters

  itemType | The item type.
  parentLayout | The parent layout to which this group belongs.

## ◆ setupDocumentationGroup()

void ClassifierListPage::setupDocumentationGroup | ( | int | margin | ) |
| private

Sets up the documentation group.

Parameters

  margin | The margin of the group.

## ◆ setupListGroup()

void ClassifierListPage::setupListGroup | ( | int | margin | ) |
| private

Sets up the list group.

Parameters

  margin | The margin of the group.

## ◆ setupMoveButtons()

void ClassifierListPage::setupMoveButtons | ( | QHBoxLayout * | parentLayout | ) |
| private

Sets up the move up/down buttons.

Parameters

  parentLayout | The parent layout to which this group belongs.

## ◆ setupPage()

void ClassifierListPage::setupPage | ( |  | ) |
| private

Sets up the page.

## ◆ slotActivateItem

void ClassifierListPage::slotActivateItem | ( | QListWidgetItem * | item | ) |
| protectedslot

Called whenever the list item needs to be activated calls enableWidgets().

## ◆ slotBottomClicked

void ClassifierListPage::slotBottomClicked | ( |  | ) |
| protectedslot

Moved selected attribute to the bottom of the list.

## ◆ slotDelete

void ClassifierListPage::slotDelete | ( |  | ) |
| protectedslot

Removes currently selected attribute.

## ◆ slotDoubleClick

void ClassifierListPage::slotDoubleClick | ( | QListWidgetItem * | item | ) |
| protectedslot

Shows properties dialog for the attribute clicked on.

## ◆ slotDownClicked

void ClassifierListPage::slotDownClicked | ( |  | ) |
| protectedslot

Moved selected attribute down in list.

## ◆ slotListItemCreated

void ClassifierListPage::slotListItemCreated | ( | UMLObject * | object | ) |
| protectedslot

## ◆ slotListItemModified

void ClassifierListPage::slotListItemModified | ( |  | ) |
| protectedslot

## ◆ slotMenuSelection

void ClassifierListPage::slotMenuSelection | ( | QAction * | action | ) |
| protectedslot

Called when an item is selected in a right click menu.

## ◆ slotNewListItem

void ClassifierListPage::slotNewListItem | ( |  | ) |
| protectedslot

Shows dialog for new attribute.

## ◆ slotProperties

void ClassifierListPage::slotProperties | ( |  | ) |
| protectedslot

Shows properties dialog for currently selected attribute.

## ◆ slotRightButtonPressed

void ClassifierListPage::slotRightButtonPressed | ( | const QPoint & | p | ) |
| protectedslot

## ◆ slotTopClicked

void ClassifierListPage::slotTopClicked | ( |  | ) |
| protectedslot

Moves selected attribute to the top of the list.

## ◆ slotUpClicked

void ClassifierListPage::slotUpClicked | ( |  | ) |
| protectedslot

Moves selected attribute up in list.

## ◆ takeItem()

bool ClassifierListPage::takeItem | ( | UMLClassifierListItem * | listItem,
|  | bool | seekPeerBefore,
|  | int & | peerIndex
| ) |  |
| private

Take a classifier's subordinate item. Ownership of the classifier list item is transferred to the caller.

Parameters

  listItem | UMLClassifierListItem to take.
  seekPeerBefore | True if a peer index should be sought which is smaller than the current listitem's index.
  peerIndex | Return value: Index in the UMLClassifier's item list at which a peer item, i.e. another UMLClassifierListItem of the same type as listItem, is found. If no such item exists then return -1.

Returns
  True for success.

## Member Data Documentation

## ◆ m_bSigWaiting

bool ClassifierListPage::m_bSigWaiting
| protected

## ◆ m_doc

UMLDoc* ClassifierListPage::m_doc
| private

## ◆ m_docGB

QGroupBox* ClassifierListPage::m_docGB
| private

## ◆ m_docTE

KTextEdit* ClassifierListPage::m_docTE
| private

## ◆ m_itemType

UMLObject::ObjectType ClassifierListPage::m_itemType
| protected

## ◆ m_pBottomArrowB

QToolButton* ClassifierListPage::m_pBottomArrowB
| private

## ◆ m_pClassifier

UMLClassifier* ClassifierListPage::m_pClassifier
| protected

## ◆ m_pCodeTE

CodeTextEdit* ClassifierListPage::m_pCodeTE
| private

## ◆ m_pDeleteListItemButton

QPushButton* ClassifierListPage::m_pDeleteListItemButton
| protected

## ◆ m_pDownArrowB

QToolButton* ClassifierListPage::m_pDownArrowB
| private

## ◆ m_pItemListGB

QGroupBox* ClassifierListPage::m_pItemListGB
| private

## ◆ m_pItemListLB

QListWidget* ClassifierListPage::m_pItemListLB
| private

## ◆ m_pLastObjectCreated

UMLClassifierListItem* ClassifierListPage::m_pLastObjectCreated
| protected

## ◆ m_pNewClassifierListItemButton

QPushButton* ClassifierListPage::m_pNewClassifierListItemButton
| protected

## ◆ m_pOldListItem

UMLClassifierListItem* ClassifierListPage::m_pOldListItem
| private

## ◆ m_pPropertiesButton

QPushButton* ClassifierListPage::m_pPropertiesButton
| protected

## ◆ m_pTopArrowB

QToolButton* ClassifierListPage::m_pTopArrowB
| private

## ◆ m_pUpArrowB

QToolButton* ClassifierListPage::m_pUpArrowB
| private

The documentation for this class was generated from the following files:

- umbrello/dialogs/pages/classifierlistpage.h
- umbrello/dialogs/pages/classifierlistpage.cpp